/*	
 *	framsn7.c
 *
 *	P/ECE SN76489/SN76496 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 12 18:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Mar 30 19:00:00 JST 2004 Naoyuki Sawa
 *	- ̂߁A炩volumeXP[OĂ悤ɂ܂B
 *	- sn76489_tone_process(),sn76489_noise_process()ɂāA
 *	  {[0̏ꍇ͒ɏԂ悤ɂ܂B
 *	  ĂȂ`l΍҂ł܂B
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

int
sn76489_process(SN76489* sn, int cycle)
{
	int sample;

	/* e`l̏o͂܂B */
	sample = sn76489_tone_process(sn, &sn->tone[0], cycle)
	       + sn76489_tone_process(sn, &sn->tone[1], cycle)
	       + sn76489_tone_process(sn, &sn->tone[2], cycle)
	       + sn76489_noise_process(sn, &sn->noise, cycle);

	/* ŏIo͂t16bit(+)ƂȂ悤A炩volumeXP[OĂ܂B
	 * ŏo̓TvXP[OKv͂܂B
	 */

	return sample;
}

int
sn76489_tone_process(SN76489* sn, SN76489TONE* tone, int cycle)
{
	int volume, period;

	/* {[擾܂B */
	volume = tone->volume;
	if(!volume) return 0;

	/* 擾܂B */
	period = tone->period;
	if(!period) return 0;

	tone->progress += cycle;
	while(tone->progress >= period) {
		tone->progress -= period;
		tone->output = !tone->output;
	}

	return tone->output ? volume : -volume;
}

int
sn76489_noise_process(SN76489* sn, SN76489NOISE* noise, int cycle)
{
	int volume, period, parity, n;

	/* {[擾܂B */
	volume = noise->volume;
	if(!volume) return 0;

	/* 擾܂B */
	period = noise->period;
	if(!period) period = sn->tone[2].period;
	if(!period) return 0;

	noise->progress += cycle;
	while(noise->progress >= period) {
		noise->progress -= period;
		parity = 0; /* peB */
		for(n = noise->lfsr & noise->feedback; n; n >>= 1) {
			parity ^= n & 1;
		}
		noise->lfsr = (noise->lfsr >> 1) | (parity << 15);
	}

	return noise->lfsr & 1 ? volume : -volume;
}

/****************************************************************************
 *	
 ****************************************************************************/

void
sn76489_mix(SN76489* sn, short wbuff[/*count*/], int count)
{
	int cycle;
	int sample;

	while(count > 0) {
		/* o߃TCN߂܂B */
		cycle = sn->progress.u;
		sn->progress.d += sn->progress.n;
		if(sn->progress.d >= 0) {
			sn->progress.d -= SPEAKER_FREQUENCY;
			cycle++;
		}

		/* 1Tv~LVO܂B */
		sample = sn76489_process(sn, cycle);

		/* NbsOĊi[܂B */
		if(sample < -0x7fff) sample = -0x7fff;
		if(sample >  0x7fff) sample =  0x7fff;
		*wbuff++ = sample;

		/* cTv炵܂B */
		count--;
	}
}

